/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

#define NAME_EE		"ee"
#define NAME_EE_UP	"EE"  /* must be NAME_EE in uppercase */

static int tnum = 0;
static int tnum_label = 8765;

char *name_out (name)
char *name;
{
	T_Entry *entry;
	char *nameout;

	if ((entry = lookup_all_glo_bef (name)) != TN) {
		if ((name = entry->tempname) == (char*) 0) {
			sprintf (serr, "name [%s]", entry->orig_name);
			syserr (serr);
			nameout = entry->orig_name;
		}

		nameout = entry->tempname;
	}
	else {
/*
		sprintf (serr, "name %s", name);
		syserr (serr);
*/

		nameout = name;
	}

	return nameout;
}

char *name_label (name)
char *name;
{
	char *tempname, *p;

	if (name [0] == '#') {
		tempname = (char*) U_malloc (strlen (name));
		strcpy (tempname, &(name [1]));
	}
	else
		tempname = name;

	return tempname;
}

static char *name_temp (name)
char *name;
{
	char *tempname, *p;

	if (name[0] != '$')
		SYSERR;

	tempname = U_str_copy (name);
	tempname[0] = 'T';

	for (p = tempname; *p != '\0'; p++)
		if (*p == '$')
			*p = 'T';
		else if (*p == '@')
			*p = 'E';

	return tempname;
}

/* BOZKUS */
char *myname_temp (name)
char *name;
{
	char *tempname, *p;

	if (name[0] == '@') {
		tempname =
		(char*) U_malloc (sizeof (char) * strlen (name) + strlen (NAME_EE) + 1);

		sprintf (tempname, "%s%s", NAME_EE, name + 1);
	}
	else {
		tempname = U_str_copy (name);
	}

	for (p = tempname; *p != '\0'; p++)
		if (*p == '$')
			*p = 'T';

	return tempname;
}

static char *name_temp_glo (name)
char *name;
{
	char *tempname, *p;

	if (name[0] == '@') {
		tempname =
		(char*) U_malloc (sizeof (char) * strlen (name) + strlen (NAME_EE) + 1);

		sprintf (tempname, "%s%s", NAME_EE, name + 1);
	}
	else {
		tempname = U_str_copy (name);
	}

	for (p = tempname; *p != '\0'; p++)
		if (*p == '$')
			*p = 'T';

	return tempname;
}

char *name_label_num ()
{
	char *name, tname [10];

	sprintf (tname, "%d", tnum_label++);

	name = U_str_copy (tname);

	return name;
}

static char *name_temp_num ()
{
	char *name, tname[10];

	tname[0] = '\0';
	sprintf (tname , "T%d", tnum++);


#ifdef CHECK
	if (strlen (tname) >= 10)
		SYSERR;
#endif

	name = U_str_copy (tname);

	return name;
}

/*
Fixes naming problem. The only conflict may be with external user variables
that start with NAME_EE. Treats the rest by creating temporaries that do not
conflict and by changing internal user variables that start with "EE" to "EU".
*/

name_end ()  /* gives output names to all variables */
{
	T_Entry *entry;
	char *name, *tempname, *Uname;

	for_TABLE_LOOP (entry) {
		name = entry->orig_name;
		Uname = entry->name;

		if (IS_temporary (entry)) {
			tempname = name_temp (name);

			while (lookup_all (tempname) != TN) {
				U_free (tempname);
				tempname = name_temp_num ();
			}
		}
		else if (IS_label_temp (entry)) {
			tempname = name_label (name);

			while (lookup_all (tempname) != TN) {
				U_free (tempname);
				tempname = name_label_num ();
			}
		}
		else if (!IS_result (entry)
		&& !strncmp (Uname, NAME_EE_UP, strlen (NAME_EE_UP))) {
			tempname = U_str_copy (name);
			tempname[1] = 'U';

			while (lookup_all (tempname) != TN) {
				U_free (tempname);
				tempname = name_temp_num ();
			}
		}
		else {
			tempname = name;
		}

		entry->tempname = tempname;
	}

	for_TABLE_LOOP_glo (entry) {
		name = entry->orig_name;
		Uname = entry->name;

		if (name[0] == '@') {
			tempname = name_temp_glo (entry->orig_name);

			if (lookup_all (tempname) != TN) {
				sprintf (serr, "conflict with '%s'", tempname);
				fatal (serr);
			}
		}
		else if (!IS_intrinsic (entry)
		&& !strncmp (Uname, NAME_EE_UP, strlen (NAME_EE_UP))) {
			sprintf (serr
			, "external user variable '%s' may conflict with system externals"
			, name);
			warning (serr);

			tempname = name;
		}
		else {
			tempname = name;
		}

		entry->tempname = tempname;
	}

	tnum = 0;
}

/********************************* W R I T E ***********************************/

write_Name (node)
Node *node;
{
	onam (node->com.str);
}
